CfnLocationSMB L1 construct
The AWS::DataSync::LocationSMB resource specifies a Server Message Block (SMB) location that AWS DataSync can use as a transfer source or destination.
| CloudFormation | AWS::DataSync::LocationSMB |
|---|---|
| Source | |
| Type last changed |
Example
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_datasync as datasync } from 'aws-cdk-lib';
const cfnLocationSMB = new datasync.CfnLocationSMB(this, 'MyCfnLocationSMB', {
agentArns: ['agentArns'],
// the properties below are optional
authenticationType: 'authenticationType',
cmkSecretConfig: {
kmsKeyArn: 'kmsKeyArn',
secretArn: 'secretArn',
},
customSecretConfig: {
secretAccessRoleArn: 'secretAccessRoleArn',
secretArn: 'secretArn',
},
dnsIpAddresses: ['dnsIpAddresses'],
domain: 'domain',
kerberosKeytab: 'kerberosKeytab',
kerberosKrb5Conf: 'kerberosKrb5Conf',
kerberosPrincipal: 'kerberosPrincipal',
mountOptions: {
version: 'version',
},
password: 'password',
serverHostname: 'serverHostname',
subdirectory: 'subdirectory',
tags: [{
key: 'key',
value: 'value',
}],
user: 'user',
});
from aws_cdk import CfnTag
# The code below shows an example of how to instantiate this type.
# The values are placeholders you should change.
from aws_cdk import aws_datasync as datasync
cfn_location_smb = datasync.CfnLocationSMB(self, "MyCfnLocationSMB",
agent_arns=["agentArns"],
# the properties below are optional
authentication_type="authenticationType",
cmk_secret_config=datasync.CfnLocationSMB.CmkSecretConfigProperty(
kms_key_arn="kmsKeyArn",
secret_arn="secretArn"
),
custom_secret_config=datasync.CfnLocationSMB.CustomSecretConfigProperty(
secret_access_role_arn="secretAccessRoleArn",
secret_arn="secretArn"
),
dns_ip_addresses=["dnsIpAddresses"],
domain="domain",
kerberos_keytab="kerberosKeytab",
kerberos_krb5_conf="kerberosKrb5Conf",
kerberos_principal="kerberosPrincipal",
mount_options=datasync.CfnLocationSMB.MountOptionsProperty(
version="version"
),
password="password",
server_hostname="serverHostname",
subdirectory="subdirectory",
tags=[CfnTag(
key="key",
value="value"
)],
user="user"
)
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import software.amazon.awscdk.services.datasync.*;
CfnLocationSMB cfnLocationSMB = CfnLocationSMB.Builder.create(this, "MyCfnLocationSMB")
.agentArns(List.of("agentArns"))
// the properties below are optional
.authenticationType("authenticationType")
.cmkSecretConfig(CmkSecretConfigProperty.builder()
.kmsKeyArn("kmsKeyArn")
.secretArn("secretArn")
.build())
.customSecretConfig(CustomSecretConfigProperty.builder()
.secretAccessRoleArn("secretAccessRoleArn")
.secretArn("secretArn")
.build())
.dnsIpAddresses(List.of("dnsIpAddresses"))
.domain("domain")
.kerberosKeytab("kerberosKeytab")
.kerberosKrb5Conf("kerberosKrb5Conf")
.kerberosPrincipal("kerberosPrincipal")
.mountOptions(MountOptionsProperty.builder()
.version("version")
.build())
.password("password")
.serverHostname("serverHostname")
.subdirectory("subdirectory")
.tags(List.of(CfnTag.builder()
.key("key")
.value("value")
.build()))
.user("user")
.build();
// Install: dotnet add package Amazon.CDK.Lib
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
using Amazon.CDK.AWS.DataSync;
var cfnLocationSMB = new CfnLocationSMB(this, "MyCfnLocationSMB", new CfnLocationSMBProps {
AgentArns = new [] { "agentArns" },
// the properties below are optional
AuthenticationType = "authenticationType",
CmkSecretConfig = new CmkSecretConfigProperty {
KmsKeyArn = "kmsKeyArn",
SecretArn = "secretArn"
},
CustomSecretConfig = new CustomSecretConfigProperty {
SecretAccessRoleArn = "secretAccessRoleArn",
SecretArn = "secretArn"
},
DnsIpAddresses = new [] { "dnsIpAddresses" },
Domain = "domain",
KerberosKeytab = "kerberosKeytab",
KerberosKrb5Conf = "kerberosKrb5Conf",
KerberosPrincipal = "kerberosPrincipal",
MountOptions = new MountOptionsProperty {
Version = "version"
},
Password = "password",
ServerHostname = "serverHostname",
Subdirectory = "subdirectory",
Tags = new [] { new CfnTag {
Key = "key",
Value = "value"
} },
User = "user"
});
// Install: go get github.com/aws/aws-cdk-go/awscdk/v2
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import "github.com/aws/aws-cdk-go/awscdk"
cfnLocationSMB := awscdk.Aws_datasync.NewCfnLocationSMB(this, jsii.String("MyCfnLocationSMB"), &CfnLocationSMBProps{
AgentArns: []*string{
jsii.String("agentArns"),
},
// the properties below are optional
AuthenticationType: jsii.String("authenticationType"),
CmkSecretConfig: &CmkSecretConfigProperty{
KmsKeyArn: jsii.String("kmsKeyArn"),
SecretArn: jsii.String("secretArn"),
},
CustomSecretConfig: &CustomSecretConfigProperty{
SecretAccessRoleArn: jsii.String("secretAccessRoleArn"),
SecretArn: jsii.String("secretArn"),
},
DnsIpAddresses: []*string{
jsii.String("dnsIpAddresses"),
},
Domain: jsii.String("domain"),
KerberosKeytab: jsii.String("kerberosKeytab"),
KerberosKrb5Conf: jsii.String("kerberosKrb5Conf"),
KerberosPrincipal: jsii.String("kerberosPrincipal"),
MountOptions: &MountOptionsProperty{
Version: jsii.String("version"),
},
Password: jsii.String("password"),
ServerHostname: jsii.String("serverHostname"),
Subdirectory: jsii.String("subdirectory"),
Tags: []CfnTag{
&CfnTag{
Key: jsii.String("key"),
Value: jsii.String("value"),
},
},
User: jsii.String("user"),
})
Initializer
new CfnLocationSMB(scope: Construct, id: string, props: CfnLocationSMBProps)
CfnLocationSMB(scope: Construct, id: str, props: CfnLocationSMBProps)
new CfnLocationSMB(Construct scope, String id, CfnLocationSMBProps props)
new CfnLocationSMB(Construct scope, string id, CfnLocationSMBProps props)
NewCfnLocationSMB(Scope Construct, Id *string, Props CfnLocationSMBProps)
Construct Props
agentArnsstring[]agent_arnstyping.List[str]agentArnsList<String>AgentArnsstring[]AgentArns*[]*string required #You specify an agent by using its Amazon Resource Name (ARN).
authenticationTypeoptionalstringauthentication_typeoptionalstrauthenticationTypeoptionalStringAuthenticationTypeoptionalstringAuthenticationTypeoptional*string #cmkSecretConfigoptionalIResolvable | CfnLocationSMB.cmk_secret_configoptionaltyping.Union[IResolvable, CmkSecretConfigProperty]cmkSecretConfigoptionalIResolvableCmkSecretConfigoptionalIResolvableCmkSecretConfigoptionalinterface{} #You can use either
CmkSecretConfigorCustomSecretConfigto provide credentials for aCreateLocationrequest. Do not provide both parameters for the same request.
customSecretConfigoptionalIResolvable | CfnLocationSMB.custom_secret_configoptionaltyping.Union[IResolvable, CustomSecretConfigProperty]customSecretConfigoptionalIResolvableCustomSecretConfigoptionalIResolvableCustomSecretConfigoptionalinterface{} #notes
This configuration includes the secret ARN, and the ARN for an IAM role that provides access to the secret.
You can use either
CmkSecretConfigorCustomSecretConfigto provide credentials for aCreateLocationrequest. Do not provide both parameters for the same request.
dnsIpAddressesoptionalstring[]dns_ip_addressesoptionaltyping.List[str]dnsIpAddressesoptionalList<String>DnsIpAddressesoptionalstring[]DnsIpAddressesoptional*[]*string #This parameter applies only if AuthenticationType is set to KERBEROS. If you have multiple domains in your environment, configuring this parameter makes sure that DataSync connects to the right SMB file server.
domainoptionalstringdomainoptionalstrdomainoptionalStringDomainoptionalstringDomainoptional*string #This parameter applies only if AuthenticationType is set to NTLM .
If you have multiple domains in your environment, configuring this parameter makes sure that DataSync connects to the right file server.
kerberosKeytaboptionalstringkerberos_keytaboptionalstrkerberosKeytaboptionalStringKerberosKeytaboptionalstringKerberosKeytaboptional*string #notes
Specifies your Kerberos key table (keytab) file, which includes mappings between your service principal name (SPN) and encryption keys. To avoid task execution errors, make sure that the SPN in the keytab file matches exactly what you specify for KerberosPrincipal and in your krb5.conf file.
kerberosKrb5Confoptionalstringkerberos_krb5_confoptionalstrkerberosKrb5ConfoptionalStringKerberosKrb5ConfoptionalstringKerberosKrb5Confoptional*string #kerberosPrincipaloptionalstringkerberos_principaloptionalstrkerberosPrincipaloptionalStringKerberosPrincipaloptionalstringKerberosPrincipaloptional*string #notes
SPNs are case sensitive and must include a prepended cifs/. For example, an SPN might look like cifs/kerberosuser@EXAMPLE.COM. Your task execution will fail if the SPN that you provide for this parameter doesn't match exactly what's in your keytab or krb5.conf files.
mountOptionsoptionalIResolvable | CfnLocationSMB.mount_optionsoptionaltyping.Union[IResolvable, MountOptionsProperty]mountOptionsoptionalIResolvableMountOptionsoptionalIResolvableMountOptionsoptionalinterface{} #passwordoptionalstringpasswordoptionalstrpasswordoptionalStringPasswordoptionalstringPasswordoptional*string #This parameter applies only if AuthenticationType is set to NTLM .
serverHostnameoptionalstringserver_hostnameoptionalstrserverHostnameoptionalStringServerHostnameoptionalstringServerHostnameoptional*string #If you're using Kerberos authentication, you must specify a domain name.
subdirectoryoptionalstringsubdirectoryoptionalstrsubdirectoryoptionalStringSubdirectoryoptionalstringSubdirectoryoptional*string #notes
You can include a subdirectory in the share path (for example, /path/to/subdirectory ). Make sure that other SMB clients in your network can also mount this path.
To copy all data in the subdirectory, DataSync must be able to mount the SMB share and access all of its data. For more information, see Providing DataSync access to SMB file servers .
tagsoptionalCfnTag[]tagsoptionaltyping.List[CfnTag]tagsoptionalList<CfnTag>TagsoptionalCfnTag[]Tagsoptional*[]CfnTag #We recommend creating at least a name tag for your location.
notes
This parameter applies only if AuthenticationType is set to NTLM .
For information about choosing a user with the right level of access for your transfer, see Providing DataSync access to SMB file servers .
Properties
agentArnsstring[]agent_arnstyping.List[str]agentArnsList<String>AgentArnsstring[]AgentArns*[]*string #attrCmkSecretConfigSecretArnstringattr_cmk_secret_config_secret_arnstrattrCmkSecretConfigSecretArnStringAttrCmkSecretConfigSecretArnstringAttrCmkSecretConfigSecretArn*string #This property is generated by DataSync and is read-only. DataSync encrypts this secret with the KMS key that you specify for KmsKeyArn .
attrLocationArnstringattr_location_arnstrattrLocationArnStringAttrLocationArnstringAttrLocationArn*string #attrLocationUristringattr_location_uristrattrLocationUriStringAttrLocationUristringAttrLocationUri*string #attrManagedSecretConfigIResolvableattr_managed_secret_configIResolvableattrManagedSecretConfigIResolvableAttrManagedSecretConfigIResolvableAttrManagedSecretConfigIResolvable #DataSync uses the default AWS-managed KMS key to encrypt this secret in AWS Secrets Manager.
authenticationTypemay be undefinedstringauthentication_typemay be undefinedstrauthenticationTypemay be undefinedStringAuthenticationTypemay be undefinedstringAuthenticationTypemay be undefined*string #CFN_RESOURCE_TYPE_NAMEstringCFN_RESOURCE_TYPE_NAMEstrCFN_RESOURCE_TYPE_NAMEStringCFN_RESOURCE_TYPE_NAMEstringCFN_RESOURCE_TYPE_NAME*string static #cfnOptionsICfnResourceOptionscfn_optionsICfnResourceOptionscfnOptionsICfnResourceOptionsCfnOptionsICfnResourceOptionsCfnOptionsICfnResourceOptions #cfnResourceTypestringcfn_resource_typestrcfnResourceTypeStringCfnResourceTypestringCfnResourceType*string #cmkSecretConfigmay be undefinedIResolvable | CfnLocationSMB.cmk_secret_configmay be undefinedtyping.Union[IResolvable, CmkSecretConfigProperty]cmkSecretConfigmay be undefinedIResolvableCmkSecretConfigmay be undefinedIResolvableCmkSecretConfigmay be undefinedinterface{} #creationStackstring[]creation_stacktyping.List[str]creationStackList<String>CreationStackstring[]CreationStack*[]*string #customSecretConfigmay be undefinedIResolvable | CfnLocationSMB.custom_secret_configmay be undefinedtyping.Union[IResolvable, CustomSecretConfigProperty]customSecretConfigmay be undefinedIResolvableCustomSecretConfigmay be undefinedIResolvableCustomSecretConfigmay be undefinedinterface{} #dnsIpAddressesmay be undefinedstring[]dns_ip_addressesmay be undefinedtyping.List[str]dnsIpAddressesmay be undefinedList<String>DnsIpAddressesmay be undefinedstring[]DnsIpAddressesmay be undefined*[]*string #domainmay be undefinedstringdomainmay be undefinedstrdomainmay be undefinedStringDomainmay be undefinedstringDomainmay be undefined*string #kerberosKeytabmay be undefinedstringkerberos_keytabmay be undefinedstrkerberosKeytabmay be undefinedStringKerberosKeytabmay be undefinedstringKerberosKeytabmay be undefined*string #kerberosKrb5Confmay be undefinedstringkerberos_krb5_confmay be undefinedstrkerberosKrb5Confmay be undefinedStringKerberosKrb5Confmay be undefinedstringKerberosKrb5Confmay be undefined*string #kerberosPrincipalmay be undefinedstringkerberos_principalmay be undefinedstrkerberosPrincipalmay be undefinedStringKerberosPrincipalmay be undefinedstringKerberosPrincipalmay be undefined*string #locationSmbRefLocationSMBReferencelocation_smb_refLocationSMBReferencelocationSmbRefLocationSMBReferenceLocationSmbRefLocationSMBReferenceLocationSmbRefLocationSMBReference #The logical ID of the element is calculated from the path of the resource node in the construct tree.
To override this value, use overrideLogicalId(newLogicalId).
mountOptionsmay be undefinedIResolvable | CfnLocationSMB.mount_optionsmay be undefinedtyping.Union[IResolvable, MountOptionsProperty]mountOptionsmay be undefinedIResolvableMountOptionsmay be undefinedIResolvableMountOptionsmay be undefinedinterface{} #passwordmay be undefinedstringpasswordmay be undefinedstrpasswordmay be undefinedStringPasswordmay be undefinedstringPasswordmay be undefined*string #If, by any chance, the intrinsic reference of a resource is not a string, you could coerce it to an IResolvable through Lazy.any({ produce: resource.ref }).
serverHostnamemay be undefinedstringserver_hostnamemay be undefinedstrserverHostnamemay be undefinedStringServerHostnamemay be undefinedstringServerHostnamemay be undefined*string #CfnElements must be defined within a stack scope (directly or indirectly).
subdirectorymay be undefinedstringsubdirectorymay be undefinedstrsubdirectorymay be undefinedStringSubdirectorymay be undefinedstringSubdirectorymay be undefined*string #tagsRawmay be undefinedCfnTag[]tags_rawmay be undefinedtyping.List[CfnTag]tagsRawmay be undefinedList<CfnTag>TagsRawmay be undefinedCfnTag[]TagsRawmay be undefined*[]CfnTag #usermay be undefinedstringusermay be undefinedstrusermay be undefinedStringUsermay be undefinedstringUsermay be undefined*string #Methods
addDeletionOverride(path: string): voiddef add_deletion_override(self, path: str) -> Nonepublic void addDeletionOverride(String path)public void AddDeletionOverride(string path)func AddDeletionOverride(Path *string) #1 parameter
Parameters
pathpathpathpathPath— The path of the value to delete.
addDependency(target: CfnResource): voiddef add_dependency(self, target: CfnResource) -> Nonepublic void addDependency(CfnResource target)public void AddDependency(CfnResource target)func AddDependency(Target CfnResource) deprecated #This method has been renamed to addResourceDependency to more clearly set it apart from construct.node.addDependency. See the documentation of that function for more details.
addDependsOn(target: CfnResource): voiddef add_depends_on(self, target: CfnResource) -> Nonepublic void addDependsOn(CfnResource target)public void AddDependsOn(CfnResource target)func AddDependsOn(Target CfnResource) deprecated #notes
This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.
This method has been renamed to addResourceDependency, which makes it more clear that this method operates at a different level from the construct-level construct.node.addDependency() mechanism.
addMetadata(key: string, value: any): voiddef add_metadata(self, key: str, value: Any) -> Nonepublic void addMetadata(String key, Object value)public void AddMetadata(string key, object value)func AddMetadata(Key *string, Value interface{}) #addOverride(path: string, value: any): voiddef add_override(self, path: str, value: Any) -> Nonepublic void addOverride(String path, Object value)public void AddOverride(string path, object value)func AddOverride(Path *string, Value interface{}) #notes · 2 parameters
To add a property override, either use addPropertyOverride or prefix path with "Properties." (i.e. Properties.TopicName).
If the override is nested, separate each nested level using a dot (.) in the path parameter. If there is an array as part of the nesting, specify the index in the path.
To include a literal . in the property name, prefix with a \. In most programming languages you will need to write this as "\\." because the \ itself will need to be escaped.
For example,
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
would add the overrides
"Properties": {
"GlobalSecondaryIndexes": [
{
"Projection": {
"NonKeyAttributes": [ "myattribute" ]
...
}
...
},
{
"ProjectionType": "INCLUDE"
...
},
]
...
}
The value argument to addOverride will not be processed or translated in any way. Pass raw JSON values in here with the correct capitalization for CloudFormation. If you pass CDK classes or structs, they will be rendered with lowercased key names, and CloudFormation will reject the template.
Parameters
pathpathpathpathPath— - The path of the property, you can use dot notation to override values in complex types.valuevaluevaluevalueValue— - The value.
addPropertyDeletionOverride(propertyPath: string): voiddef add_property_deletion_override(self, property_path: str) -> Nonepublic void addPropertyDeletionOverride(String propertyPath)public void AddPropertyDeletionOverride(string propertyPath)func AddPropertyDeletionOverride(PropertyPath *string) #1 parameter
Parameters
propertyPathproperty_pathpropertyPathpropertyPathPropertyPath— The path to the property.
addPropertyOverride(propertyPath: string, value: any): voiddef add_property_override(self, property_path: str, value: Any) -> Nonepublic void addPropertyOverride(String propertyPath, Object value)public void AddPropertyOverride(string propertyPath, object value)func AddPropertyOverride(PropertyPath *string, Value interface{}) #Syntactic sugar for addOverride("Properties.<...>", value).
2 parameters
Parameters
propertyPathproperty_pathpropertyPathpropertyPathPropertyPath— The path of the property.valuevaluevaluevalueValue— The value.
addResourceDependency(target: CfnResource, reason?: string): voiddef add_resource_dependency(self, target: CfnResource, reason: typing.Optional[str] = None) -> Nonepublic void addResourceDependency(CfnResource target, String reason)public void AddResourceDependency(CfnResource target, string? reason = null)func AddResourceDependency(Target CfnResource, Reason *string) #notes
This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.
This method only adds dependencies between L1 resources. If you are looking for a generic construct-to-construct dependency mechanism that works for all constructs including L2s, use construct.node.addDependency instead.
applyCrossStackReferenceStrength(strength: ReferenceStrength): voiddef apply_cross_stack_reference_strength(self, strength: ReferenceStrength) -> Nonepublic void applyCrossStackReferenceStrength(ReferenceStrength strength)public void ApplyCrossStackReferenceStrength(ReferenceStrength strength)func ApplyCrossStackReferenceStrength(Strength ReferenceStrength) #When set, any cross-stack reference to this resource will use the specified strength instead of the global default from the consuming stack's context.
1 parameter
Parameters
strengthstrengthstrengthstrengthStrength— - The reference strength to use for this resource.
applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): voiddef apply_removal_policy(self, policy: typing.Optional[RemovalPolicy] = None, options: typing.Optional[RemovalPolicyOptions] = None) -> Nonepublic void applyRemovalPolicy(RemovalPolicy policy, RemovalPolicyOptions options)public void ApplyRemovalPolicy(RemovalPolicy? policy = null, RemovalPolicyOptions? options = null)func ApplyRemovalPolicy(Policy RemovalPolicy, Options RemovalPolicyOptions) #notes
The Removal Policy controls what happens to this resource when it stops being managed by CloudFormation, either because you've removed it from the CDK application or because you've made a change that requires the resource to be replaced.
The resource can be deleted (RemovalPolicy.DESTROY), or left in your AWS account for data recovery and cleanup later (RemovalPolicy.RETAIN). In some cases, a snapshot can be taken of the resource prior to deletion (RemovalPolicy.SNAPSHOT). A list of resources that support this policy can be found in the following link:
cfnPropertyName(cdkPropertyName: string): stringdef cfn_property_name(self, cdk_property_name: str) -> strpublic String cfnPropertyName(String cdkPropertyName)public string CfnPropertyName(string cdkPropertyName)func CfnPropertyName(CdkPropertyName *string) *string #getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Referencedef get_att(self, attribute_name: str, type_hint: typing.Optional[ResolutionTypeHint] = None) -> Referencepublic Reference getAtt(String attributeName, ResolutionTypeHint typeHint)public Reference GetAtt(string attributeName, ResolutionTypeHint? typeHint = null)func GetAtt(AttributeName *string, TypeHint ResolutionTypeHint) Reference #Ideally, use generated attribute accessors (e.g. resource.arn), but this can be used for future compatibility in case there is no generated attribute.
1 parameter
Parameters
attributeNameattribute_nameattributeNameattributeNameAttributeName— The name of the attribute.
getMetadata(key: string): anydef get_metadata(self, key: str) -> Anypublic Object getMetadata(String key)public object GetMetadata(string key)func GetMetadata(Key *string) interface{} #inspect(inspector: TreeInspector): voiddef inspect(self, inspector: TreeInspector) -> Nonepublic void inspect(TreeInspector inspector)public void Inspect(TreeInspector inspector)func Inspect(Inspector TreeInspector) #1 parameter
Parameters
inspectorinspectorinspectorinspectorInspector— tree inspector to collect and process attributes.
isCfnElement(x: any): boolean@staticmethod def is_cfn_element(x: Any) -> boolpublic static Boolean isCfnElement(Object x)public static bool IsCfnElement(object x)func IsCfnElement(X interface{}) *bool static #Uses duck-typing instead of instanceof to allow stack elements from different versions of this library to be included in the same stack.
returns
Returns: The construct as a stack element or undefined if it is not a stack element.
isCfnLocationSMB(x: any): boolean@staticmethod def is_cfn_location_smb(x: Any) -> boolpublic static Boolean isCfnLocationSMB(Object x)public static bool IsCfnLocationSMB(object x)func IsCfnLocationSMB(X interface{}) *bool static #isCfnResource(x: any): boolean@staticmethod def is_cfn_resource(x: Any) -> boolpublic static Boolean isCfnResource(Object x)public static bool IsCfnResource(object x)func IsCfnResource(X interface{}) *bool static #isConstruct(x: any): boolean@staticmethod def is_construct(x: Any) -> boolpublic static Boolean isConstruct(Object x)public static bool IsConstruct(object x)func IsConstruct(X interface{}) *bool static #notes · 1 parameter · returns
Use this method instead of instanceof to properly detect Construct instances, even when the construct library is symlinked.
Explanation: in JavaScript, multiple copies of the constructs library on disk are seen as independent, completely different libraries. As a consequence, the class Construct in each copy of the constructs library is seen as a different class, and an instance of one class will not test as instanceof the other class. npm install will not create installations like this, but users may manually symlink construct libraries together or use a monorepo tool: in those cases, multiple copies of the constructs library can be accidentally installed, and instanceof will behave unpredictably. It is safest to avoid using instanceof, and using this type-testing method instead.
Parameters
xxxxX— Any object.
Returns: true if x is an object created from a class which extends Construct.
obtainDependencies(): Stack | CfnResource[]def obtain_dependencies(self, ) -> typing.List[typing.Union[Stack, CfnResource]]public List<Stack> obtainDependencies()public Stack[] ObtainDependencies()func ObtainDependencies() *[]interface{} #For resources depended on directly, returns the CfnResource object. For dependencies on other stacks, returns the Stack object. The order of the array is not guaranteed.
overrideLogicalId(newLogicalId: string): voiddef override_logical_id(self, new_logical_id: str) -> Nonepublic void overrideLogicalId(String newLogicalId)public void OverrideLogicalId(string newLogicalId)func OverrideLogicalId(NewLogicalId *string) #1 parameter
Parameters
newLogicalIdnew_logical_idnewLogicalIdnewLogicalIdNewLogicalId— The new logical ID to use for this stack element.
removeDependency(target: CfnResource): voiddef remove_dependency(self, target: CfnResource) -> Nonepublic void removeDependency(CfnResource target)public void RemoveDependency(CfnResource target)func RemoveDependency(Target CfnResource) deprecated #This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.
removeResourceDependency(target: CfnResource): voiddef remove_resource_dependency(self, target: CfnResource) -> Nonepublic void removeResourceDependency(CfnResource target)public void RemoveResourceDependency(CfnResource target)func RemoveResourceDependency(Target CfnResource) #This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.
replaceDependency(target: CfnResource, newTarget: CfnResource): voiddef replace_dependency(self, target: CfnResource, new_target: CfnResource) -> Nonepublic void replaceDependency(CfnResource target, CfnResource newTarget)public void ReplaceDependency(CfnResource target, CfnResource newTarget)func ReplaceDependency(Target CfnResource, NewTarget CfnResource) #2 parameters
Parameters
targettargettargettargetTarget— The dependency to replace.newTargetnew_targetnewTargetnewTargetNewTarget— The new dependency to add.
toString(): stringdef to_string(self, ) -> strpublic String toString()public string ToString()func ToString() *string #returns
Returns: a string representation of this resource
with(...mixins: IMixin[]): IConstructdef with(self, mixins: IMixin) -> IConstructpublic IConstruct with(IMixin mixins)public IConstruct With(IMixin mixins)func With(Mixins IMixin) IConstruct #Mixins are applied in order. The list of constructs is captured at the start of the call, so constructs added by a mixin will not be visited. Use multiple with() calls if subsequent mixins should apply to added constructs.